import java.util.Random;

public final class RSys {
  int attributes;
  int objects;
  boolean verbose;

  double[][] D;//
  double[][] z;//z[n][k] = component n of cluster k
  double[][] w;
  double[][] W;
  float[] sig2 = new float[500];   //sig2[k] = variance of cluster k
  float s=0f;                    //s = merging parameter
  float XB=0f;                   //modified Xie=Beni clustering validity
  int N, K;                //N<=40, K<=500, Q<=600 (don't use J)
  int KK;                        //no. clusters after merging
  int[] clust = new int[1000];     //clust[q] = k, qth vector is in class k
  int[] count = new int[500];      //count[k] = no. vectors in class k
  int[] Merge = new int[500];      //indicator for cluster k being merged
  int minp;                      //eliminate clusters with p or less vectors
  int elimtotal;           //total number of vectors in eliminated clusters
  int I;            //no. iterations given by user for a run
  int I_max, sumits;    //the total number of iterations so far
  String infilename;       //input file of feature vectors
  String outfilename;
  int Q;double Sum=0;
  Matrix table;



  public RSys(Matrix fm,int o,int a,int k,int it,boolean v) {
    table=fm;
    objects = o;
    Q=objects;
    attributes = a-1; //don't consider classification
    N = attributes;
    K=k;
    I_max = it;
    D = new double[Q][K];
    z = new double[N][K];
    w = new double[Q][K];
    W = new double[Q][K];
    
    verbose=v;
    
  }

  public final void fuzzyCluster() {
    initWeights();
    standInitWeights();
    for (I=0;I<I_max;I++) {
      standClusWeights();
      computePrototypes();
      computeWeights();
    }
    output();
  }

  public final void initWeights() {
    Random rand = new Random();
    for (int k=0;k<K;k++) {
      for (int q=0;q<Q;q++) {
	w[q][k] = rand.nextDouble();
      }
    }
  }
  
  public final void standInitWeights() {
    for (int q=0;q<Q;q++) {//for each feature vector
      Sum=0;
      for (int k=0;k<K;k++) {//sum over all k prototypes
	Sum+=w[q][k];
      }
      for (int k=0;k<K;k++) {
	w[q][k]/=Sum; //standardize over K
      }
    }
  }

  public final void standClusWeights() {
    for (int k=0;k<K;k++) {//for each cluster k
      Sum=0;
      for (int q=0;q<Q;q++) { //sum over all Q
	Sum += w[q][k];
      }
      for (int q=0;q<Q;q++) {
	W[q][k] = w[q][k]/Sum; //standardize over Q
      }
    }
  }

  //compute new prototype vectors
  public final void computePrototypes() {
    for (int k=0;k<K;k++) {
      for (int n=0;n<N;n++) { //attributes
	Sum=0;
	for (int q=0;q<Q;q++) {//objects
	  Sum += W[q][k]*table.getCell(q,n);//o,a
	}
	z[n][k] = Sum; //prototype equals weighted sum
      }
    }
  }

  public final void computeWeights() {
    double temp=0f;
    double p = 2;

    for (int q=0;q<Q;q++) {
      Sum=0;
      for (int k=0;k<K;k++) {
	D[q][k] = 0.0;
	for (int n=0;n<N;n++) {
	  temp = table.getCell(q,n) - z[n][k];
	  D[q][k] += temp*temp ;
	}
	Sum += Math.pow((1/D[q][k]),1/(p-1));//sum of distance reciprocals
      }
      for (int k=0;k<K;k++) {
	w[q][k] = Math.pow((1/D[q][k]),1/(p-1))/Sum; //standardize weights
      }
    }
  }
  
  public final void output() {
    BitSet[] clusters = new BitSet[K];
    for (int c=0;c<K;c++) {
      clusters[c] = new BitSet(Q);
    }

    for (int q=0;q<Q;q++) { //for each object
      double bestval=-99;
      int bestk=0;
      for (int k=0;k<K;k++) { // for each cluster
	//System.out.println(w[q][k]);
	if (w[q][k]>bestval) {
	  bestval = w[q][k];
	  bestk = k;
	}
      }
      clusters[bestk].set(q);
    }

    for (int c=0;c<K;c++) {
      System.out.println(clusters[c]);
    }
  }
}
