import java.util.StringTokenizer;
import java.io.*;

public final class fkmeans {
  public final static void main(String[] args) throws Exception {
    String filename;
    int condition_attributes = 0; 
    int decision_attributes  = 0;  
    int clusters=0;int iterations=0;
    float threshold=0f;

    boolean verbose = false;
    int s=0,f=0;
    int idx = 1;

    if (args.length!=3) {
      System.out.println("Usage:  java fkmeans <dataset> <No. of Clusters> <Iterations>");
      System.exit(1);
    }

    filename = args[0];  

    clusters = Integer.parseInt(args[1]);
    iterations = Integer.parseInt(args[2]);
    //threshold = (Float.valueOf(args[2])).floatValue();

    //read in the dataset
    BufferedReader in = new BufferedReader(new FileReader(filename));
    String line = in.readLine();
    StringTokenizer st = new StringTokenizer(line," ,");

    //calculate the number of columns (attributes)
    int cols=0;
    while(st.hasMoreTokens()) {
      st.nextToken();
      cols++;
    }

    //calculate the number of rows (objects)
    int rows =0;
    while(line!=null&&line.length()>0) {
      rows++;
      line = in.readLine();
    }
    
    in = new BufferedReader(new FileReader(args[0]));
    Matrix m = new Matrix(rows,cols);

    System.out.println("<== Fuzzy k-means clustering algorithm ==>");
    line = in.readLine();
    String tok;

    //construct the dataset (stored in a Matrix object, m)
    for (int i=0;i<rows;i++) {
      st = new StringTokenizer(line," ,");
      for (int j=0;j<cols;j++) {
        tok = st.nextToken();
        double val;
        if (tok.equals("?")) val=0;
        else val = Double.valueOf(tok).doubleValue();
        m.setCell(i,j,val);
      }
      line = in.readLine();
      if (line==null) break;
    }
    in.close();

    RSys sys = new RSys(m,rows,cols,clusters,iterations,verbose);
    System.out.println(cols+" attributes in dataset.");
    System.out.println(rows+" objects in dataset.\n");

    long start = System.currentTimeMillis(); 

    //generate the reduced set of attributes using focus algorithm
    sys.fuzzyCluster();

    float time = (float) (System.currentTimeMillis() - start);
    System.out.println("Time taken = "+(time/60000)+" mins");
  }
}
